<?php
/**
 * SynergeticAgency_Gls
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magento.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Magento to newer
 * versions in the future. If you wish to customize Magento for your
 * needs please refer to http://www.magento.com for more information.
 *
 * @category    SynergetigAgency
 * @package     SynergeticAgency_GlsConnector
 * @copyright  Copyright (c) 2016-2017 synergetic agency AG (http://agency.synergetic.ag)
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

/**
 * Class to work with archives
 *
 * @category    SynergetigAgency
 * @package     SynergeticAgency_GlsConnector_Model
 * @author      PHP WebDevelopment <php.webdevelopment@synergetic.ag>
 */
class SynergeticAgency_GlsConnector_Model_JsonConfig
{

	/**
	 * @var	array	the service object converted into an array i.e. to generate correct GLS-JSON
	 */
	private $glsArray;

	/**
	 * @var string $countryCode	ISO-31661 alpha 2
	 */
	private $countryCode;


	/**
	 *
	 */
	function __construct() {

	}

	/**
	 * @return array
	 */
	private function toGlsArray() {
		#echo "\n\nEntering " . __METHOD__ . " @ line " . __LINE__ . ":" . $this->getShopDelivery();
		$returnValue = array();

		/** @var $parcel SynergeticAgency_GlsConnector_Model_Services */
		if( $this->getShopDelivery() !== NULL )			$returnValue['ShopDelivery'] =		$this->getShopDelivery();
		if( $this->getNotificationEmail() !== NULL )	$returnValue['NotificationEmail'] =	$this->getNotificationEmail();
		if( $this->getDeposit() !== NULL )				$returnValue['Deposit'] =			$this->getDeposit();
		if( $this->getShopReturn() !== NULL )			$returnValue['ShopReturn'] =		$this->getShopReturn();

		#echo "\n\nLeave " . __METHOD__ . " @ line " . __LINE__ . ":" . var_export( $returnValue, 1);

		$this->setGlsArray( $returnValue );

		return $returnValue;
	}

	/**
	 * @return array
	 */
	public function getConstants() {
		$oClass = new ReflectionClass(__CLASS__);
		return $oClass->getConstants();
	}

	/**
	 * @return mixed
	 */
	public function getGlsArray() {
		return $this->glsArray;
	}

	/**
	 * @param $glsArray
	 * @return $this
	 */
	public function setGlsArray($glsArray) {
		$this->glsArray = $glsArray;
		return $this;
	}

	/**
	 * @param $key
	 * @param $value
	 * @return $this
	 */
	public function addGlsArrayValue( $key, $value ) {
		$this->glsArray[$key] = $value;
		return $this;
	}

	/**
	 * @return string
	 */
	public function getCountryCode() {
		return $this->countryCode;
	}

	/**
	 * @param string $countryCode
	 */
	public function setCountryCode($countryCode) {
		$this->countryCode = $countryCode;
	}


}